/*->h.fcet */


/* Type definitions */

typedef long int32;             /* 32 bit integer */
typedef unsigned long uint32;   /* 32 bit unsigned integer */


#define FAL_LOAD        (1)     /* Load address exists */
#define FAL_EXEC        (2)     /* Execution address exists */

/* Offset into arg array for each argument type */

#define FAI_LOAD        (0)     /* Load address */
#define FAI_EXEC        (1)     /* Execution address */

/* Structure to give and return FCET header arguments */

struct Fcetargs {
        int     arglist;        /* Bitmask to indicate which args exist */
        int32   length;         /* The file length */
        int32   arg[8];         /* The 8 possible arguments */
        char    filename[13];   /* Null terminated file name */
};


/* Global function definitions */

extern void     fcet_init(void); /* Decoder and encoder initialisation */


/***************************  DECODER DEFINITIONS  ***************************/

#ifdef FCET_DECODER

/* Return code values */

#define FRC_OK          (0)     /* Call successful */
#define FRC_NOTFCET     (1)     /* File not in FCET format */
#define FRC_CHECKSUM    (2)     /* Checksum error */
#define FRC_FORMAT      (3)     /* Internal format fault */


/* Global function definitions */

extern int      fcetdec_hdr(FILE *, struct Fcetargs *);
extern int      fcetdec_data(FILE *, int32 *);

#endif


/***************************  ENCODER DEFINITIONS  ***************************/

#ifdef FCET_ENCODER

/* Global function definitions */

extern void     fcetenc_hdr(struct Fcetargs *);
extern void     fcetenc_tail(void);
extern void     fcetenc_l2(int);

/* Function supplied by calling module */

extern void     fcetenc_out(int);

#endif
